Imports Microsoft.VisualBasic
Imports System.ComponentModel
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Text.RegularExpressions
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' (c) 2005 by Michael Hreth (michael(at)pentabyte.de)
' Copyright Restriction:
'   You may use this component for no charge, if you keep the copyright notice
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Namespace Pentabyte.WebControls

    Public Class GalleryProperty
        Public AllowOriginal As Boolean = True
        Public Columns As Integer = 4
        Public CopyrightInfo As String = "(c) Pentabyte"
        Public EnableOrderForm As Boolean = False
        Public ExcludeDirectories As String
        Public FolderStyleClass As String
        Public ID As String
        Public isLicenced As Boolean = true
        Public Language As Gallery.LanguageType = Gallery.LanguageType.en
        Public LicenceKey As String = ""
        Public _myURI As System.Uri
        Public OrderBy As String = "Name"
        Public ReverseOrder As Boolean = False
        Public Paging As Boolean = True
        Public PopupHeight As Integer = 600
        Public PopupWidth As Integer = 800
        Public PopupScaling As Boolean = True
        Public RootDirectory As String = "."
        Public Rows As Integer = 4
        Public SMTPhost As String = "localhost"
        Public SMTPuser As String = ""
        Public SMTPpassword As String = ""
        Public SMTPrecipient As String = ""
        Public TableStyleClass As String
        Public ThumbnailStyleClass As String
        Public ThumbWidth As Integer = 125
        Public ThumbHeight As Integer = 125
        Public WatermarkImage As String = ""
        Public ZoomToFit As Boolean = False
    End Class

    Public Class Gallery
        Inherits System.Web.UI.WebControls.WebControl

        ' Da die Properties fr den ThumbHandler nicht mehr direkt zur Verfgung stehen, werden die Properties
        ' hier fr jeden Gallery-Tag gecacht
        ' Wie identifiziert man den Gallerie-Tag? 
        ' URL#Gallerie-ID als Hash Key
        Public Shared PublicGalleryProperties As System.Collections.Hashtable = New System.Collections.Hashtable

        Private myProperty As GalleryProperty = New GalleryProperty

        Private Shared hasPinged As Boolean = False    ' zeigt an, ob die Gallerie bereits ein Ping an pentabyte.de abgesetzt hat

        Public Const ThumbnailFolder As String = "_Thumbs"
        Public Const ThumbHandlerURL As String = "Pentabyte.WebControls.ThumbHandler.aspx"

        Private Directory As String  ' ist ein absoluter Festplattenpfad, auf dem im Moment gearbeitet wird
        Private Header As Label = New Label
        Private Footer As String
        Private CurrentPage As Integer
        Private Pages As Integer = 0
        Private Subdir As String = ""
        Private ThumbNumber As Integer  ' die berechnete Gesamtzahl der Thumbs auf einer seite
        Private TotalImages As Integer ' gesamte anzahl der Eintrge fr das gewhlte Subdir
        Private pics As ArrayList
        Private hashkey As String

        Public Property AllowOriginal() As Boolean
            Get
                Return myProperty.AllowOriginal
            End Get
            Set(ByVal Value As Boolean)
                myProperty.AllowOriginal = Value
            End Set
        End Property

        Public Property Columns() As Integer
            Get
                Return myProperty.Columns
            End Get
            Set(ByVal Value As Integer)
                myProperty.Columns = Value
            End Set
        End Property

        Public Property EnableOrderForm() As Boolean
            Get
                Return myProperty.EnableOrderForm
            End Get
            Set(ByVal Value As Boolean)
                myProperty.EnableOrderForm = Value
            End Set
        End Property

        Public Property FolderStyleClass() As String
            Get
                Return myProperty.FolderStyleClass
            End Get
            Set(ByVal value As String)
                myProperty.FolderStyleClass = value
            End Set
        End Property

        Public Property OrderBy() As String
            Get
                Return myProperty.OrderBy
            End Get
            Set(ByVal value As String)
                myProperty.OrderBy = value
            End Set
        End Property

        Public Property ReverseOrder() As Boolean
            Get
                Return myProperty.ReverseOrder
            End Get
            Set(ByVal value As Boolean)
                myProperty.ReverseOrder = value
            End Set
        End Property

        Public Property Rows() As Integer
            Get
                Return myProperty.Rows
            End Get
            Set(ByVal Value As Integer)
                myProperty.Rows = Value
            End Set
        End Property

        Public Property TableStyleClass() As String
            Get
                Return myProperty.TableStyleClass
            End Get
            Set(ByVal value As String)
                myProperty.TableStyleClass = value
            End Set
        End Property

        Public Property ThumbWidth() As Integer
            Get
                Return myProperty.ThumbWidth
            End Get
            Set(ByVal Value As Integer)
                myProperty.ThumbWidth = Value
            End Set
        End Property

        Public Property ThumbHeight() As Integer
            Get
                Return myProperty.ThumbHeight
            End Get
            Set(ByVal Value As Integer)
                myProperty.ThumbHeight = Value
            End Set
        End Property

        Public Property ThumbnailStyleClass() As String
            Get
                Return myProperty.ThumbnailStyleClass
            End Get
            Set(ByVal value As String)
                myProperty.ThumbnailStyleClass = value
            End Set
        End Property

        Public Property PopupWidth() As Integer
            Get
                Return myProperty.PopupWidth
            End Get
            Set(ByVal Value As Integer)
                myProperty.PopupWidth = Value
            End Set
        End Property

        Public Property PopupHeight() As Integer
            Get
                Return myProperty.PopupHeight
            End Get
            Set(ByVal Value As Integer)
                myProperty.PopupHeight = Value
            End Set
        End Property


        Public Property PopupScaling() As Boolean
            Get
                Return myProperty.PopupScaling
            End Get
            Set(ByVal Value As Boolean)
                myProperty.PopupScaling = Value
            End Set
        End Property

        Public Property Paging() As Boolean
            Get
                Return myProperty.Paging
            End Get
            Set(ByVal Value As Boolean)
                myProperty.Paging = Value
            End Set
        End Property

        Public Property RootDirectory() As String
            Get
                Return myProperty.RootDirectory
            End Get
            Set(ByVal Value As String)
                myProperty.RootDirectory = Value
            End Set
        End Property


        Public Property SMTPhost() As String
            Get
                Return myProperty.SMTPhost
            End Get
            Set(ByVal Value As String)
                myProperty.SMTPhost = Value
            End Set
        End Property

        Public Property SMTPuser() As String
            Get
                Return myProperty.SMTPuser
            End Get
            Set(ByVal Value As String)
                myProperty.SMTPuser = Value
            End Set
        End Property

        Public Property SMTPpassword() As String
            Get
                Return myProperty.SMTPpassword
            End Get
            Set(ByVal Value As String)
                myProperty.SMTPpassword = Value
            End Set
        End Property

        Public Property SMTPrecipient() As String
            Get
                Return myProperty.SMTPrecipient
            End Get
            Set(ByVal Value As String)
                myProperty.SMTPrecipient = Value
            End Set
        End Property

        Public Property ZoomToFit() As Boolean
            Get
                Return myProperty.ZoomToFit
            End Get
            Set(ByVal Value As Boolean)
                myProperty.ZoomToFit = Value
            End Set
        End Property

        Private Function checkLicence(ByVal licence As String) As Boolean
            Return True
        End Function

        Function isHiddenDirectory(ByVal path As String) As Boolean
            ' ACHTUNG: DOUBLETTE  Gallerie - Thumbhandler
            Dim name As String = FileIO.FileSystem.GetName(path)
            Dim excludes As String = ThumbnailFolder & "|_notes|App_*|Bin"
            If myProperty.ExcludeDirectories <> "" Then
                excludes = excludes & "|" & myProperty.ExcludeDirectories
            End If

            excludes = Replace(excludes, "*", ".*") ' regex-konform machen
            excludes = "^" & excludes & "$"

            If Regex.Match(name, excludes, RegexOptions.IgnoreCase).Success Then
                Return True
            Else
                Return False
            End If
        End Function

        Public Property ExcludeDirectories() As String
            Get
                Return myProperty.ExcludeDirectories
            End Get
            Set(ByVal Value As String)
                myProperty.ExcludeDirectories = Value
            End Set
        End Property

        Public Enum LanguageType
            de = 1
            en = 2
            fr = 3
            nl = 4
        End Enum

        Public Property Language() As LanguageType
            Get
                Return myProperty.Language
            End Get
            Set(ByVal Value As LanguageType)
                myProperty.Language = Value
            End Set
        End Property

        Public Property LicenceKey() As String
            Get
                Return myProperty.LicenceKey
            End Get
            Set(ByVal value As String)
                myProperty.LicenceKey = value
            End Set
        End Property

        Public Property WatermarkImage() As String
            Get
                Return myProperty.WatermarkImage
            End Get
            Set(ByVal value As String)
                myProperty.WatermarkImage = value
            End Set
        End Property

        Private Function Request(ByVal param As String) As String
            Return HttpContext.Current.Server.UrlDecode(HttpContext.Current.Request(Me.ID & "_" & param))
        End Function

        Function getJavascriptAnchor(ByVal funcname As String) As String
            Return "<a href=""javascript:" & Me.ID & "_" & funcname & ";"">"
        End Function


        Public Sub ProcessRequest()
            hashkey = (HttpContext.Current.Request.Path & "#" & Me.ID).GetHashCode.ToString()

            If PublicGalleryProperties.ContainsKey(hashkey) Then
                PublicGalleryProperties.Remove(hashkey)
            End If

            myProperty.ID = Me.ID
            myProperty._myURI = Context.Request.Url
            PublicGalleryProperties.Add(hashkey, myProperty)


            If Request("CurrentPage") <> "" Then
                CurrentPage = Request("CurrentPage")
            Else
                CurrentPage = 1
            End If
            ThumbNumber = Columns * Rows

            If Request("Subdir") <> "" Then
                Subdir = Request("Subdir")
                Subdir = Subdir.Replace("{plus}", "+")
            Else
                Subdir = ""
            End If

            If Subdir.Contains("..") Then
                Throw New System.Exception("invalid characters in Subdir-Parameter")
            End If

            Dim temp As String
            temp = myProperty.RootDirectory & "/" & Subdir
            If System.IO.Path.IsPathRooted(temp) Then
                Directory = temp
            Else
                Directory = HttpContext.Current.Server.MapPath(temp)
            End If

        End Sub

        Public Sub InitHeaderLabel()
            ' setzt die Kopfzeile
            Dim SubdirDisplay As String ' so wies oben steht
            SubdirDisplay = Me.ID & "/" & Subdir
            If Right(SubdirDisplay, 1) = "/" Then
                SubdirDisplay = Left(SubdirDisplay, SubdirDisplay.Length - 1)
            End If
            Dim buttons As String() = Split(SubdirDisplay, "/")
            Dim name As String, dir As String, dir_slash As String
            dir = ""
            For i As Integer = LBound(buttons) To UBound(buttons)
                name = buttons(i)
                If i > LBound(buttons) + 1 Then
                    dir = dir & "/" & buttons(i)
                End If
                If i = LBound(buttons) + 1 Then
                    dir = buttons(i)
                End If
                If dir.Length > 0 Then dir_slash = dir & "/" Else dir_slash = dir
                buttons(i) = Me.getJavascriptAnchor("setPage(1,'" & dir_slash.Replace("'", "\'") & "')") & name & "</a>"
            Next
            Header.Text = Join(buttons, " / ")
        End Sub

        Public Sub InitPicsArray()
            pics = New ArrayList

            Dim pics2 As ArrayList = New ArrayList

            Dim directories As System.Collections.ObjectModel.ReadOnlyCollection(Of String) = FileIO.FileSystem.GetDirectories(Directory, FileIO.SearchOption.SearchTopLevelOnly)
            Dim counter As Integer = 0
            Dim startbild As Integer = (CurrentPage - 1) * ThumbNumber + 1
            Dim stopbild As Integer = (CurrentPage) * ThumbNumber

            For Each d As String In directories
                If Not isHiddenDirectory(d) Then    ' denn die wollen wir ja nicht im Fotoalbum
                    counter = counter + 1
                    If counter >= startbild And counter <= stopbild Then
                        pics.Add(d)
                    End If
                End If
            Next

            order(pics)

            For i As Integer = 0 To pics.Count - 1
                pics.Item(i) = pics.Item(i) & "\"
            Next

            Dim search As String() = {"*.jpg", "*.gif", "*.bmp", "*.tif", "*.tiff", "*.png"}
            Dim files As System.Collections.ObjectModel.ReadOnlyCollection(Of String) = FileIO.FileSystem.GetFiles(Directory, FileIO.SearchOption.SearchTopLevelOnly, search)

            For Each f As String In files
                If System.IO.Path.GetFileName(f) <> myProperty.WatermarkImage Then
                    counter = counter + 1
                    If Paging Then
                        If counter >= startbild And counter <= stopbild Then
                            pics2.Add(f)
                        End If
                    Else
                        pics2.Add(f)
                    End If
                End If
            Next

            order(pics2)

            For Each f As String In pics2
                pics.Add(f)
            Next

            TotalImages = counter
        End Sub

        Private Sub order(ByRef a As ArrayList)
            Select Case myProperty.OrderBy
                Case "Name"
                    If myProperty.ReverseOrder Then a.Reverse()
                Case "Created"
                    Dim hilf As New ArrayList
                    For Each f As String In a
                        hilf.Add(New TimeComparator(f, FileIO.FileSystem.GetFileInfo(f).CreationTime))
                    Next
                    hilf.Sort()
                    If myProperty.ReverseOrder Then hilf.Reverse()
                    a.Clear()
                    For Each h As TimeComparator In hilf
                        a.Add(h.getName)
                    Next
            End Select
        End Sub

        Private Class TimeComparator
            Implements System.IComparable

            Private _file As String
            Private _time As Date

            Public Sub New(ByVal file As String, ByVal modified As Date)
                _file = file
                _time = modified
            End Sub

            Public Function getName() As String
                Return _file
            End Function

            Public Function CompareTo(ByVal o As Object) As Integer Implements IComparable.CompareTo
                Dim second As TimeComparator = o
                Return _time.CompareTo(second._time)
            End Function

        End Class

        Public Sub InitFooterLabel()
            Footer = ""
            If Paging Then
                Footer = "<table width=""100%"" border=""0""><tr>"
                If CurrentPage = 1 Then
                    Footer += "<td width=""20%"">&nbsp;</td>"
                Else
                    Footer += "<td align=""center"" width=""20%""><font size=""1""> " _
                & getJavascriptAnchor("setPage(" & CurrentPage - 1 & ",'" & Subdir.Replace("'", "\'") & "')") & "&lt;= " & translate("back") & "</a></font></td>"
                End If

                Dim pages As Integer = 0
                Dim num As Integer = TotalImages
                While num > 0
                    pages = pages + 1
                    num -= ThumbNumber
                End While
                If pages = 0 Then pages = 1
                Dim myto As Integer
                If CurrentPage * ThumbNumber > TotalImages Then
                    myto = TotalImages
                Else
                    myto = CurrentPage * ThumbNumber
                End If

                Footer += "<td nowrap=""nowrap""><center><font size=""1"">" & translate("Page") & " " & CurrentPage & " " & translate("of") & " " & pages _
              & "</font></center></td>"

                If CurrentPage = pages Then
                    Footer += "<th width=""20%"">&nbsp;  </th>"
                Else
                    Footer += "<td align=""center"" width=""20%""><font size=""1""> " _
                & getJavascriptAnchor("setPage(" & CurrentPage + 1 & ",'" & Subdir.Replace("'", "\'") & "')") & translate("next") & " =&gt;</a></font></td>"
                End If
                Footer += "</tr></table>"
            Else
                Footer = ""
            End If
        End Sub

        Private Sub Gallery_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            ' Hauptfunktion
            ProcessRequest()

            ' Die berschrift mit Links schreiben
            InitHeaderLabel()

            ' Bilder auslesen
            InitPicsArray()

            ' Footer schreiben
            InitFooterLabel()

        End Sub

        Protected Overrides Sub Render(ByVal writer As System.Web.UI.HtmlTextWriter)
            writer.Write("<script type='text/javascript'>" & vbCrLf)
            writer.Write("<!--  " & vbCrLf)
            writer.Write("  function " & Me.ID & "_setPage(i,subdir){")
            writer.Write("      subdir=subdir.replace(/\+/, '{plus}');")
            writer.Write("      document.forms[0]." & Me.ID & "_CurrentPage.value=i;")
            writer.Write("      document.forms[0]." & Me.ID & "_Subdir.value=subdir;")
            writer.Write("      document.forms[0].submit();")
            writer.Write("  }")
            writer.Write("  function " & Me.ID & "_showImg(img){")
            writer.Write("      img=encodeURI(img);")
            writer.Write("      img=img.replace(/\+/,'{plus}');")
            writer.Write("      img=img.replace(/ /, '+');")
            writer.Write("      window.open('" & ThumbHandlerURL & "?preview=normal&imgURL=' + (img) + '&ID=" & Me.hashkey & "','Detailansicht','width=" & myProperty.PopupWidth + 40 & ",height=" & myProperty.PopupHeight + 50 & ",left=20,top=20,resizeable=yes,scrollbars=yes');")
            writer.Write("  }" & vbCrLf)
            writer.Write("//-->" & vbCrLf)
            writer.Write("</script>")
            Dim tableStyleClass As String
            If myProperty.TableStyleClass = Nothing Then
                tableStyleClass = ""
            Else
                tableStyleClass = " class='" & myProperty.TableStyleClass & "' "
            End If
            writer.WriteLine("<table border='0' cellpadding='1' cellspacing='0'" & tableStyleClass & ">")
            Dim row As Integer
            Dim col As Integer
            writer.WriteLine("    <tr><td colspan='" & myProperty.Columns & "'>")
            Header.RenderControl(writer)
            writer.WriteLine("  </td></tr>")
            For row = 0 To System.Math.Ceiling(pics.Count / myProperty.Columns) - 1
                writer.WriteLine()
                writer.WriteLine("  <tr>")
                For col = 0 To myProperty.Columns - 1
                    writer.Write("  <td>")
                    If row * myProperty.Columns + col < pics.Count Then
                        RenderItem(pics(row * myProperty.Columns + col), writer)
                    Else
                        writer.WriteLine("  &nbsp;")
                    End If
                    writer.Write("  </td>")
                Next
                writer.WriteLine("  </tr>")
            Next
            writer.WriteLine("    <tr><td align='center' colspan='" & myProperty.Columns & "'>")
            writer.WriteLine(Footer)
            writer.WriteLine("  </td></tr>")
            writer.WriteLine("</table>")
            writer.Write("<input type='hidden' name='" & Me.ID & "_CurrentPage' id='" & Me.ID & "_CurrentPage' value='" & CurrentPage & "'/>")
            writer.Write("<input type='hidden' name='" & Me.ID & "_Subdir' id='" & Me.ID & "_Subdir' value='" & HttpContext.Current.Server.UrlEncode(Subdir) & "'/>")
            myProperty.isLicenced = checkLicence(myProperty.LicenceKey)
            If Not hasPinged Then
                ' checkt auch noch die Lizenzinfo
                If Not myProperty.isLicenced Then writer.Write("<img src=""http://www.pentabyte.de/WebControls.Gallery.Ping.aspx"" width=""0"" height=""0""/>")
                hasPinged = True
            End If
            writer.Write(vbCrLf & myProperty.CopyrightInfo)
        End Sub

        Private Sub RenderItem(ByVal path As String, ByRef writer As System.Web.UI.HtmlTextWriter)
            Dim html As String, bildlink As String, dirname As String, temp As String

            If System.IO.Path.IsPathRooted(myProperty.RootDirectory) Then
                temp = myProperty.RootDirectory
            Else
                temp = HttpContext.Current.Server.MapPath(myProperty.RootDirectory)
            End If

            bildlink = Right(path, path.Length - temp.Length - 1)
            bildlink = Replace(bildlink, "\", "/")

            Dim title As String, pos As Int16
            pos = InStrRev(bildlink, "/")
            If (pos = 0) Then
                title = bildlink
            Else
                title = Right(bildlink, Len(bildlink) - pos)
            End If

            If Right(path, 1) = "\" Then
                Dim folderStyleClass As String
                If myProperty.FolderStyleClass = Nothing Then
                    folderStyleClass = ""
                Else
                    folderStyleClass = " class='" & myProperty.FolderStyleClass & "' "
                End If
                dirname = Right(path, path.Length - FileIO.FileSystem.GetParentPath(path).Length)
                dirname = Replace(dirname, "\", "")
                html = getJavascriptAnchor("setPage(1,'" & bildlink.Replace("'", "\'") & "')") & dirname & "</a>"
                writer.WriteLine("      <table " & folderStyleClass & " border=""1""><tr><td height=""" & myProperty.ThumbHeight & """ width=""" & myProperty.ThumbWidth & """ align=""center"" valign=""middle"">" & html & "</td></tr></table>")
            Else
                Dim thumbnailStyleClass As String
                If myProperty.ThumbnailStyleClass = Nothing Then
                    thumbnailStyleClass = ""
                Else
                    thumbnailStyleClass = " class='" & myProperty.ThumbnailStyleClass & "' "
                End If
                html = getJavascriptAnchor("showImg('" & bildlink.Replace("'", "\'") & "')") & "<img " & thumbnailStyleClass & " border=""0"" src='Pentabyte.WebControls.ThumbHandler.aspx?imgURL=" & HttpContext.Current.Server.UrlEncode(bildlink).Replace("'", "%27") & "&amp;ID=" & hashkey & "' alt='" & title & "' title='" & title & "'/></a>"
                writer.WriteLine("      <table width=""100%"" border=""0"" cellpadding=""0""><tr><td align=""center"" valign=""middle"">" & html & "</td></tr></table>")
            End If
        End Sub

        Private Function translate(ByVal en As String) As String
            Return translate(en, myProperty.Language)
        End Function

        Public Shared Function translate(ByVal en As String, ByVal translationLanguage As LanguageType) As String
            Dim output As Collection
            output = New Collection
            Select Case en.ToString
                Case "back"
                    output.Add("zurck", LanguageType.de.ToString)
                    output.Add("en arrire", LanguageType.fr.ToString)
                    output.Add("achteruit", LanguageType.nl.ToString)
                Case "click to close window"
                    output.Add("Klicken, um Fenster zu schlieen", LanguageType.de.ToString)
                    output.Add("dclic pour fermer la fentre", LanguageType.fr.ToString)
                Case "Detailed View"
                    output.Add("Detailansicht", LanguageType.de.ToString)
                Case "e-mail"
                    output.Add("E-Mail", LanguageType.de.ToString)
                Case "freeware Version"
                    output.Add("kostenlose Version", LanguageType.de.ToString)
                Case "Image"
                    output.Add("Bild", LanguageType.de.ToString)
                Case "LicenceKey invalid"
                    output.Add("LicenceKey ungltig", LanguageType.de.ToString)
                Case "Message"
                    output.Add("Nachricht", LanguageType.de.ToString)
                Case "Name"
                    output.Add("Name", LanguageType.de.ToString)
                Case "next"
                    output.Add("weiter", LanguageType.de.ToString)
                    output.Add("en avant", LanguageType.fr.ToString)
                    output.Add("wijdere", LanguageType.nl.ToString)
                Case "of"
                    output.Add("von", LanguageType.de.ToString)
                    output.Add("de", LanguageType.fr.ToString)
                    output.Add("van", LanguageType.nl.ToString)
                Case "Original"
                    output.Add("Original", LanguageType.de.ToString)
                    output.Add("Original", LanguageType.fr.ToString)
                    output.Add("Origineel", LanguageType.nl.ToString)
                Case "Page"
                    output.Add("Seite", LanguageType.de.ToString)
                    output.Add("Page", LanguageType.fr.ToString)
                    output.Add("Zijde", LanguageType.nl.ToString)
                Case "Request from"
                    output.Add("Anfrage aus", LanguageType.de.ToString)
                Case "Request price information for this image"
                    output.Add("Preisinformationen fr dieses Bild anfordern", LanguageType.de.ToString)
                Case "send e-mail"
                    output.Add("versende E-Mail", LanguageType.de.ToString)
                Case "Thanks for your interest in that image! This E-Mail has been sent:"
                    output.Add("Danke fr Ihr Interesse an diesem Bild! Folgende E-Mail wurde versendet:", LanguageType.de.ToString)
            End Select

            Try
                Return output.Item(translationLanguage.ToString)
            Catch E As System.Exception
                Return en
            End Try

            output = Nothing
        End Function

    End Class

    Public Class ThumbHandler
        Implements IHttpHandler

        Private ThumbnailFolder As String = Pentabyte.WebControls.Gallery.ThumbnailFolder
        Private imageDirectory As String
        Private watermarkDirectory As String
        Private imageFile As String
        Private imageWidth As Integer
        Private imageheight As Integer

        Private hashkey As String

        Private myProperty As GalleryProperty

        Private pics As ArrayList

        Private Sub PrepareThumbnailFolder()
            ' schaut, ob der Ordner auch da ist, und lscht bereits vorhandene Thumbnails des
            ' aktuellen Bildes
            If Not FileIO.FileSystem.DirectoryExists(imageDirectory & "\" & ThumbnailFolder) Then
                FileIO.FileSystem.CreateDirectory(imageDirectory & "\" & ThumbnailFolder)
            End If
            Dim file As String
            Dim search As String() = {imageFile & "*"}
            For Each file In FileIO.FileSystem.GetFiles(imageDirectory & "\" & ThumbnailFolder, FileIO.SearchOption.SearchTopLevelOnly, search)
                FileIO.FileSystem.DeleteFile(file)
            Next
        End Sub

        Private Function GetThumb(ByVal imageWidth As Integer, ByVal imageHeight As Integer, ByVal caching As Boolean) As System.Drawing.Image
            ' precondition: Klassenvariablen sind alle gltig 
            Dim thumbFile As String = ""
            If imageWidth <> Nothing Then thumbFile = imageFile & "_w" & imageWidth & "h" & imageHeight & ".jpg"
            If imageWidth <> Nothing And FileIO.FileSystem.FileExists(imageDirectory & "\" & ThumbnailFolder & "\" & thumbFile) Then
                Return System.Drawing.Image.FromFile(imageDirectory & "\" & ThumbnailFolder & "\" & thumbFile)
            Else
                ' Hier muss das Thumbnail noch generiert werden

                Dim fullSizeImg As System.Drawing.Image
                Dim thumbNailImg As System.Drawing.Image
                If FileIO.FileSystem.FileExists(imageDirectory & "\" & imageFile) Then
                    fullSizeImg = System.Drawing.Image.FromFile(imageDirectory & "\" & imageFile)
                    Dim zoom As Double
                    If imageWidth = Nothing Then
                        zoom = 1
                    Else
                        zoom = imageWidth / fullSizeImg.Width
                        If (fullSizeImg.Height * zoom > imageHeight) Then
                            zoom = imageHeight / fullSizeImg.Height
                        End If
                    End If

                    thumbNailImg = New Bitmap(fullSizeImg, fullSizeImg.Width * zoom, fullSizeImg.Height * zoom)

                    fullSizeImg.Dispose()

                    If myProperty.WatermarkImage <> "" And Not caching Then
                        Dim watermark As System.Drawing.Image
                        If System.IO.File.Exists(watermarkDirectory & "\" & myProperty.WatermarkImage) Then
                            watermark = System.Drawing.Image.FromFile(watermarkDirectory & "\" & myProperty.WatermarkImage)
                        Else
                            watermark = New Bitmap(1000, 200)
                            Dim textwriter As System.Drawing.Graphics = Graphics.FromImage(watermark)
                            textwriter.DrawString(Gallery.translate("WatermarkImage not found", myProperty.Language) & vbCrLf & "(" & watermarkDirectory & "\" & myProperty.WatermarkImage & ")", New System.Drawing.Font("Arial", 20, FontStyle.Regular, GraphicsUnit.Pixel), Brushes.YellowGreen, 0, 0)
                        End If
                        Dim zoomwatermark As Double
                        zoomwatermark = thumbNailImg.Width / watermark.Width
                        If (watermark.Height * zoomwatermark > thumbNailImg.Height) Then
                            zoomwatermark = thumbNailImg.Height / watermark.Height
                        End If
                        watermark = New Bitmap(watermark, watermark.Width * zoomwatermark, watermark.Height * zoomwatermark)
                        Dim composite As System.Drawing.Graphics
                        composite = Graphics.FromImage(thumbNailImg)
                        composite.DrawImage(watermark, New System.Drawing.PointF(thumbNailImg.Width / 2 - watermark.Width / 2, thumbNailImg.Height / 2 - watermark.Height / 2))
                    End If

                    If caching Then ' wird von aussen gesteuert, ob gecacht wird
                        PrepareThumbnailFolder()
                        Try
                            thumbNailImg.Save(imageDirectory & "\" & ThumbnailFolder & "\" & thumbFile)
                        Catch e As System.Exception
                            HttpContext.Current.Response.Write("couldn't write thumbnail-file")
                            HttpContext.Current.Response.End()
                        End Try
                    End If
                Else
                    thumbNailImg = Nothing
                End If
                Return thumbNailImg
                fullSizeImg = Nothing
            End If
        End Function


        Public Sub ProcessRequest(ByVal context As System.Web.HttpContext) Implements System.Web.IHttpHandler.ProcessRequest
            Dim app As HttpApplication = context.ApplicationInstance
            Dim request As System.Web.HttpRequest = context.Request
            Dim response As System.Web.HttpResponse = context.Response

            hashkey = request("ID")
            myProperty = Gallery.PublicGalleryProperties.Item(hashkey)

            If myProperty Is Nothing Then
                response.Write("please reload the gallery and click the image again")
                response.End()
                Exit Sub
            End If

            'Read in the image filename to create a thumbnail of
            Dim imageUrl As String = request("imgURL")
            imageUrl = imageUrl.Replace("{plus}", "+")
            If request("imgURL").Contains("..") Then
                Throw New System.Exception("inproper use of imgURL- Request Parameter")
            End If

            If System.IO.Path.IsPathRooted(myProperty.RootDirectory) Then
                imageDirectory = myProperty.RootDirectory & "\" & System.IO.Path.GetDirectoryName(imageUrl)
                imageFile = System.IO.Path.GetFileName(imageUrl)
                watermarkDirectory = myProperty.RootDirectory
            Else
                imageDirectory = System.IO.Path.GetDirectoryName(context.Server.MapPath(myProperty.RootDirectory & "/" & imageUrl))
                imageFile = System.IO.Path.GetFileName(context.Server.MapPath(imageUrl))
                watermarkDirectory = context.Server.MapPath(myProperty.RootDirectory)
            End If

            Select Case request("preview")
                Case ""
                    Dim caching As Boolean = (request("size") = "")  ' hier wird ein Thumbnail angefordert

                    If request("size") = "preview" Then
                        imageWidth = myProperty.PopupWidth
                        imageheight = myProperty.PopupHeight
                        If Not myProperty.PopupScaling Then
                            imageWidth = Nothing  ' keine Vorgabe
                            imageheight = Nothing ' keine Vorgabe
                        End If
                    ElseIf request("size") = "original" Then
                        If Not myProperty.AllowOriginal Then Exit Sub
                        imageWidth = Nothing  ' keine Vorgabe
                        imageheight = Nothing ' keine Vorgabe
                    Else
                        imageWidth = myProperty.ThumbWidth
                        imageheight = myProperty.ThumbHeight
                    End If

                    If System.IO.File.Exists(imageDirectory & "\" & imageFile) Then
                        response.ContentType = "image/jpeg"
                        response.Expires = 3600
                        response.AddHeader("Content-Disposition", "inline; filename=" & HttpContext.Current.Server.UrlEncode(imageFile))
                        Dim temp As System.IO.MemoryStream
                        temp = New System.IO.MemoryStream
                        Dim Info() As System.Drawing.Imaging.ImageCodecInfo = System.Drawing.Imaging.ImageCodecInfo.GetImageEncoders()
                        Dim Params As System.Drawing.Imaging.EncoderParameters = New System.Drawing.Imaging.EncoderParameters(1)
                        Params.Param(0) = New EncoderParameter(Encoder.Quality, 98)
                        GetThumb(imageWidth, imageheight, caching).Save(temp, Info(1), Params)
                        response.AddHeader("Content-length", temp.Length)
                        response.BinaryWrite(temp.GetBuffer)
                        temp.Close()
                    Else
                        response.ContentType = "text/html"
                        response.Write("<h3>" & Gallery.translate("Image does not exist.", myProperty.Language) & "<br>(" & imageUrl & ")<br>" & LicenceInfo())
                    End If
                Case "normal"
                    response.Write("<html><head><title>" & imageUrl & "</title>")
                    writeNavButtonScript(context)
                    response.Write("</head>")
                    response.Write("<body onload='enableButtons();'>" & myProperty.PopupWidth & " x " & myProperty.PopupHeight & " ")
                    If myProperty.AllowOriginal Then response.Write("<a href=""?preview=original&imgURL=" & HttpContext.Current.Server.UrlEncode(request("imgURL")) & "&ID=" & hashkey & """>" & Gallery.translate("Original", myProperty.Language) & "</a>&nbsp;")
                    writeNavButtons(context)
                    response.Write("<br><img " & ClickToCloseAttr() & " src=""?imgURL=" & HttpContext.Current.Server.UrlEncode(request("imgURL")) & "&size=preview&ID=" & hashkey & """/>")
                    response.Write("<br>" & LicenceInfo())
                    If myProperty.EnableOrderForm Then response.Write("<br>" & OrderForm(request("imgURL")))
                    response.Write("</body></html>")
                Case "original"
                    response.Write("<html><head><title>" & request("imgURL") & "</title>")
                    writeNavButtonScript(context)
                    response.Write("</head>")
                    response.Write("<body onload='enableButtons()'><a href=""?preview=normal&imgURL=" & HttpContext.Current.Server.UrlEncode(request("imgUrl")) & "&ID=" & hashkey & """>" & myProperty.PopupWidth & " x " & myProperty.PopupHeight & "</a> " & Gallery.translate("Original", myProperty.Language) & "&nbsp;")
                    writeNavButtons(context)
                    response.Write("<br><img " & ClickToCloseAttr() & " src=""?imgURL=" & HttpContext.Current.Server.UrlEncode(request("imgURL")) & "&size=original&ID=" & hashkey & """/>")
                    response.Write("<br>" & LicenceInfo())
                    If myProperty.EnableOrderForm Then response.Write("<br>" & OrderForm(request("imgURL")))
                    response.Write("</body></html>")

                Case "sendmail"
                    Dim client As System.Net.Mail.SmtpClient = New System.Net.Mail.SmtpClient(myProperty.SMTPhost)
                    Dim mail As System.Net.Mail.MailMessage = New System.Net.Mail.MailMessage

                    Dim kleinesBild As System.Drawing.Image = GetThumb(myProperty.PopupWidth, myProperty.PopupHeight, False)

                    Dim memorystream As System.IO.MemoryStream = New System.IO.MemoryStream()
                    kleinesBild.Save(memorystream, System.Drawing.Imaging.ImageFormat.Jpeg)
                    memorystream.Seek(0, System.IO.SeekOrigin.Begin)

                    Try
                        mail.From = New System.Net.Mail.MailAddress(request("Email"), request("Name"))
                    Catch e As System.Exception
                        mail.From = New System.Net.Mail.MailAddress(myProperty.SMTPrecipient, myProperty.ID)
                    End Try

                    Dim attachment As System.Net.Mail.Attachment = New System.Net.Mail.Attachment(memorystream, System.IO.Path.GetFileName(request("imgUrl")), "image/jpg")
                    mail.Attachments.Add(attachment)

                    mail.Subject = Gallery.translate("Request from", myProperty.Language) & " " & myProperty.ID
                    mail.To.Add(myProperty.SMTPrecipient)
                    Dim body As String
                    body = "<table>"
                    body = body & "<tr><td>" & Gallery.translate("Name", myProperty.Language) & "</td>"
                    body = body & "<td>" & request("Name") & "</td></tr>"
                    body = body & "<tr><td>" & Gallery.translate("e-mail", myProperty.Language) & "</td>"
                    body = body & "<td>" & request("Email") & "</td></tr>"
                    body = body & "<tr><td>" & Gallery.translate("Image", myProperty.Language) & "</td>"
                    body = body & "<td>" & request("imgUrl") & "</td></tr>"
                    body = body & "<tr><td>" & Gallery.translate("Message", myProperty.Language) & "</td>"
                    body = body & "<td>" & request("Message") & "</td></tr>"
                    body = body & "</table>"
                    mail.IsBodyHtml = True
                    mail.Body = body & "<img src='cid:" & attachment.ContentId & "' width='" & kleinesBild.Width & "' height='" & kleinesBild.Height & "'/>"

                    client.Credentials = New System.Net.NetworkCredential(myProperty.SMTPuser, myProperty.SMTPpassword)
                    client.Send(mail)

                    response.Write("<h3>" & Gallery.translate("Thanks for your interest in that image! This E-Mail has been sent:", myProperty.Language) & "</h3><br>")
                    response.Write(body & "<img src='?size=preview&ID=" & hashkey & "&imgUrl=" & HttpContext.Current.Server.UrlEncode(request("imgURL")) & "' width='" & kleinesBild.Width & "' height='" & kleinesBild.Height & "'/>")
            End Select
        End Sub

        Private Sub writeNavButtonScript(ByVal context As System.Web.HttpContext)
            Dim response As System.Web.HttpResponse = context.Response
            response.Write("<script type='text/javascript'>")
            response.Write("function enableButtons(){")
            response.Write("    if (document.getElementById('backbutton')) document.getElementById('backbutton').disabled=false;")
            response.Write("    if (document.getElementById('nextbutton')) document.getElementById('nextbutton').disabled=false;")
            response.Write("}")
            response.Write("function disableButtons(){")
            response.Write("    if (document.getElementById('backbutton')) document.getElementById('backbutton').disabled=true;")
            response.Write("    if (document.getElementById('nextbutton')) document.getElementById('nextbutton').disabled=true;")
            response.Write("}")
            response.Write("</script>")
        End Sub

        Private Sub writeNavButtons(ByVal context As System.Web.HttpContext)
            Dim request As System.Web.HttpRequest = context.Request
            Dim response As System.Web.HttpResponse = context.Response
            InitPicsArray()
            Dim prev As String = ""
            Dim nex As String = ""
            Dim last As String = ""
            For Each file As String In pics
                If nex.Equals("MARKER") Then
                    nex = file
                End If
                If file.Equals(imageDirectory & "\" & imageFile) Or file.Equals(imageDirectory & imageFile) Then
                    prev = last
                    nex = "MARKER"
                End If
                last = file
            Next
            If nex.Equals("MARKER") Then nex = ""
            Dim prev_id As String
            Dim nex_id As String
            Dim onclick As String
            If (prev = "") Then prev_id = "" Else prev_id = " id='backbutton' "
            If (nex = "") Then nex_id = "" Else nex_id = " id='nextbutton' "


            Dim reqDir As String = ""
            If request("imgURL").LastIndexOf("/") >= 0 Then
                reqDir = request("imgURL").Substring(0, request("imgURL").LastIndexOf("/") + 1)
            End If

            If prev.LastIndexOf("\") >= 0 Then prev = prev.Substring(prev.LastIndexOf("\") + 1)
            If nex.LastIndexOf("\") >= 0 Then nex = nex.Substring(nex.LastIndexOf("\") + 1)

            onclick = "disableButtons();location.href=""" & Gallery.ThumbHandlerURL & "?preview=normal&imgURL=" & HttpContext.Current.Server.UrlEncode(reqDir & prev) & "&ID=" & hashkey & """;"
            response.Write("<input type=""button"" value=""" & Gallery.translate("back", myProperty.Language) & """ disabled " & prev_id & " onclick='" & onclick & "'/>")
            response.Write("&nbsp;")
            onclick = "disableButtons();location.href=""" & Gallery.ThumbHandlerURL & "?preview=normal&imgURL=" & HttpContext.Current.Server.UrlEncode(reqDir & nex) & "&ID=" & hashkey & """;"
            response.Write("<input type=""button"" value=""" & Gallery.translate("next", myProperty.Language) & """ disabled " & nex_id & " onclick='" & onclick & "'/>")
        End Sub

        Private Function OrderForm(ByVal image As String) As String
            Dim s As String = ""
            s = s & "<form method='get'>"
            s = s & "<input type='hidden' name='preview' value='sendmail'/>"
            s = s & "<input type='hidden' name='ID' value='" & hashkey & "'/>"
            s = s & "<input type='hidden' name='imgUrl'  value='" & image & "'/>"
            s = s & "<table border='0' cellpadding='4'>"
            s = s & "<tr><td colspan='2'>" & Gallery.translate("Request price information for this image", myProperty.Language) & "</td></tr>"
            s = s & "<tr>"
            s = s & "<td>" & Gallery.translate("Name", myProperty.Language) & "</td>"
            s = s & "<td><input type='text' name='Name'/></td>"
            s = s & "</tr>"
            s = s & "<tr>"
            s = s & "<td>" & Gallery.translate("e-mail", myProperty.Language) & "</td>"
            s = s & "<td><input type='text' name='Email'/></td>"
            s = s & "</tr>"
            s = s & "<tr>"
            s = s & "<td>" & Gallery.translate("Image", myProperty.Language) & "</td>"
            s = s & "<td>" & image & "</td>"
            s = s & "</tr>"
            s = s & "<tr>"
            s = s & "<td valign='top'>" & Gallery.translate("Message", myProperty.Language) & "</td>"
            s = s & "<td><textarea name='Message' cols='40' rows='2'></textarea></td>"
            s = s & "</tr>"
            s = s & "<tr><td></td><td><input type='submit' value='" & Gallery.translate("send e-mail", myProperty.Language) & "'/></td></tr>"
            s = s & "</form>"
            Return s
        End Function

        Private Function LicenceInfo() As String
            If myProperty.isLicenced Then
                Return ""
            Else
                Return "<font size=""1""><a href=""http://www.pentabyte.de/software/WebControls/"">Pentabyte Gallery</a> - " & Gallery.translate("freeware Version", myProperty.Language) & "</font>"
            End If
        End Function

        Private Function ClickToCloseAttr() As String
            Return " title=""" & Gallery.translate("click to close window", myProperty.Language) & """ alt=""" & Gallery.translate("click to close window", myProperty.Language) & """ onclick=""javascript:window.close();"" "
        End Function

        Public ReadOnly Property IsReusable() As Boolean Implements System.Web.IHttpHandler.IsReusable
            Get
                Return True
            End Get
        End Property

        Function isHiddenDirectory(ByVal path As String) As Boolean
            ' ACHTUNG: DOUBLETTE  Gallerie - Thumbhandler
            Dim name As String = FileIO.FileSystem.GetName(path)
            Dim excludes As String = ThumbnailFolder & "|_notes|App_*|Bin"
            If myProperty.ExcludeDirectories <> "" Then
                excludes = excludes & "|" & myProperty.ExcludeDirectories
            End If

            excludes = Replace(excludes, "*", ".*") ' regex-konform machen
            excludes = "^" & excludes & "$"

            If Regex.Match(name, excludes, RegexOptions.IgnoreCase).Success Then
                Return True
            Else
                Return False
            End If
        End Function

        Public Sub InitPicsArray()
            ' ACHTUNG: fast identisch mit Gallerie.InitPicsArray
            pics = New ArrayList
            Dim directories As System.Collections.ObjectModel.ReadOnlyCollection(Of String) = FileIO.FileSystem.GetDirectories(imageDirectory, FileIO.SearchOption.SearchTopLevelOnly)
            Dim counter As Integer = 0

            Dim search As String() = {"*.jpg", "*.gif", "*.bmp", "*.tif", "*.tiff", "*.png"}
            Dim files As System.Collections.ObjectModel.ReadOnlyCollection(Of String) = FileIO.FileSystem.GetFiles(imageDirectory, FileIO.SearchOption.SearchTopLevelOnly, search)
            For Each f As String In files
                If System.IO.Path.GetFileName(f) <> myProperty.WatermarkImage Then
                    counter = counter + 1
                    pics.Add(f)
                End If
            Next
        End Sub

    End Class

End Namespace